"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/node/index.ts
var node_exports = {};
__export(node_exports, {
  fileCopy: () => fileCopy,
  getExportBundle: () => getExportBundle,
  getPkg: () => getPkg,
  getPkgTool: () => getPkgTool,
  hasPkg: () => hasPkg,
  isInstallPkg: () => isInstallPkg,
  jsShell: () => jsShell,
  transformArgv: () => transformArgv,
  useNodeWorker: () => useNodeWorker,
  useProcressNodeWorker: () => useProcressNodeWorker,
  withTaskName: () => withTaskName,
  writeFile: () => writeFile
});
module.exports = __toCommonJS(node_exports);

// src/node/jsShell.ts
var import_node_child_process = __toESM(require("child_process"));
var import_node_process = __toESM(require("process"));

// src/is/isArray.ts
var isArray = Array.isArray;

// src/node/jsShell.ts
function jsShell(commander, options = "inherit") {
  let args = [];
  let stdio = "inherit";
  let errorExit = true;
  let isLog = false;
  let cwd;
  if (typeof options === "string") {
    stdio = options;
  } else {
    args = options.args ?? [];
    stdio = options.stdio ?? "inherit";
    errorExit = options.errorExit ?? true;
    isLog = options.isLog ?? false;
    cwd = options.cwd;
  }
  return isArray(commander) ? commander.map((command) => executor(command)) : executor(commander);
  function executor(commander2) {
    var _a;
    const { status, output, stdout, stderr, error, signal, pid } = import_node_child_process.default.spawnSync(commander2, args, {
      shell: true,
      encoding: "utf8",
      stdio: stdio === "inherit" ? "inherit" : ["inherit", "pipe", "inherit"],
      cwd
    });
    const result = (_a = output[1]) == null ? void 0 : _a.trim();
    if (status === 130) {
      if (isLog)
        console.log("\u5DF2\u53D6\u6D88...");
      return { status, result };
    }
    if (status !== 0) {
      if (isLog)
        console.log(result || (error == null ? void 0 : error.message));
      if (errorExit)
        import_node_process.default.exit(1);
    }
    return {
      status,
      result,
      stdout,
      stderr,
      error,
      signal,
      pid
    };
  }
}

// src/node/fileCopy.ts
function fileCopy(urls, destination) {
  return jsShell(`cp -r {${urls.join(",")}} ${destination}`, "pipe");
}

// src/node/getExportBundle.ts
var import_promises = __toESM(require("fs/promises"));
var import_node_path = __toESM(require("path"));
var import_node_process2 = __toESM(require("process"));
async function getExportBundle(url) {
  if (/[./]/.test(url))
    throw new Error("module must be a npm module");
  const pkg = import_node_path.default.resolve(import_node_process2.default.cwd(), "node_modules", url, "package.json");
  const { module: module2, main } = JSON.parse(await import_promises.default.readFile(pkg, "utf-8"));
  const modulePath = import_node_path.default.resolve(`./node_modules/${url}`, module2 || main);
  return import_promises.default.readFile(modulePath, "utf-8");
}

// src/node/getPkg.ts
var import_promises2 = __toESM(require("fs/promises"));

// src/is/isFile.ts
var import_node_fs = __toESM(require("fs"));

// src/utils/common.ts
var _toString = Object.prototype.toString;

// src/is/isStr.ts
function isStr(o) {
  return typeof o === "string";
}

// src/is/isFile.ts
function isFile(o) {
  if (isStr(o)) {
    try {
      return import_node_fs.default.statSync(o).isFile();
    } catch (error) {
      return false;
    }
  }
  return _toString.call(o) === "[object File]";
}

// src/string/ensureSuffix.ts
function ensureSuffix(suffix, str) {
  if (str.endsWith(suffix))
    return str;
  return str + suffix;
}

// src/to/toAbsolutePath.ts
var import_node_process3 = __toESM(require("process"));
var import_node_path2 = __toESM(require("path"));

// src/is/isAbsolute.ts
function isAbsolute(url) {
  return /^\/|^\\|^[a-z]:[/\\]/i.test(url);
}

// src/to/toAbsolutePath.ts
function toAbsolutePath(url) {
  return isAbsolute(url) ? url : import_node_path2.default.resolve(import_node_process3.default.cwd(), url);
}

// src/node/getPkg.ts
async function getPkg(url = "./package.json") {
  const resolvedPath = toAbsolutePath(ensureSuffix("/package.json", url));
  if (!isFile(resolvedPath))
    throw new Error(`${resolvedPath} is not a file`);
  return JSON.parse(await import_promises2.default.readFile(resolvedPath, "utf-8"));
}

// src/is/isExist.ts
var import_node_fs2 = __toESM(require("fs"));

// src/is/isGo.ts
var import_node_path3 = __toESM(require("path"));
var import_node_process4 = __toESM(require("process"));

// src/is/isPkg.ts
var import_node_process5 = __toESM(require("process"));
var import_node_path4 = __toESM(require("path"));

// src/is/isRust.ts
var import_node_process6 = __toESM(require("process"));
var import_node_path5 = __toESM(require("path"));

// src/is/isWin.ts
var import_node_process7 = __toESM(require("process"));

// src/is/isWritable.ts
var import_node_fs3 = __toESM(require("fs"));

// src/node/getPkgTool.ts
async function getPkgTool() {
  const pkg = await getPkg() || {};
  const { packageManager } = pkg;
  if (packageManager) {
    const manager = packageManager.split("@")[0].replace(/[~^]/, "");
    if (packageManager)
      return manager;
  }
  switch (true) {
    case isFile(toAbsolutePath("./bun.lockb")):
      return "bun";
    case isFile(toAbsolutePath("./pnpm-lock.yaml")):
    case isFile(toAbsolutePath("./pnpm-workspace.yaml")):
      return "pnpm";
    case isFile(toAbsolutePath("./yarn.lock")):
    case isFile(toAbsolutePath("./lerna.json")):
      return "yarn";
    default:
      return "npm";
  }
}

// src/node/transformArgv.ts
var import_node_process8 = __toESM(require("process"));
function transformArgv() {
  var _a, _b;
  return (_b = (_a = import_node_process8.default) == null ? void 0 : _a.argv) == null ? void 0 : _b.slice(2).reduce((result, arg) => {
    const [key, value] = arg.split("=");
    result[key.slice(2)] = value || true;
    return result;
  }, {});
}

// src/node/useNodeWorker.ts
var import_node_worker_threads = __toESM(require("worker_threads"));
var import_node_path6 = __toESM(require("path"));
var import_node_process9 = __toESM(require("process"));
var import_node_fs4 = __toESM(require("fs"));

// src/js/parallel.ts
function parallel(tasks, fn) {
  return Promise.all(tasks.map(fn));
}

// src/node/useNodeWorker.ts
async function useNodeWorker(payload, url) {
  if (!url) {
    url = import_node_path6.default.resolve(
      __dirname,
      "../node_modules/lazy-js-utils/dist/worker/useNodeWorkerThread.mjs"
    );
    if (!import_node_fs4.default.existsSync(url))
      url = import_node_path6.default.resolve(__dirname, "./worker/useNodeWorkerThread.mjs");
  }
  const { params } = isStr(payload) ? payload = { params: payload } : payload;
  const commands = isArray(params) ? params : params.split("&&");
  const result = await parallel(commands, (params2) => createWorker(
    Object.assign(payload, {
      params: params2
    })
  ));
  setTimeout(import_node_process9.default.exit);
  return result.length === 1 ? result[0] : result;
  function createWorker(payload2) {
    const { Worker } = import_node_worker_threads.default;
    return new Promise((resolve) => {
      const seprateThread = new Worker(url);
      seprateThread.on("message", resolve);
      seprateThread.postMessage(payload2);
    });
  }
}
function useProcressNodeWorker(callback) {
  const { parentPort } = import_node_worker_threads.default;
  parentPort.on("message", async (data) => parentPort == null ? void 0 : parentPort.postMessage(await (callback == null ? void 0 : callback(data)) || (() => "")));
}

// src/node/withTaskName.ts
function withTaskName(name, fn) {
  return Object.assign(fn, { displayName: name });
}

// src/node/writeFile.ts
var import_promises3 = __toESM(require("fs/promises"));
function writeFile(paths, callback, encoding = "utf-8") {
  if (isStr(paths))
    paths = [paths];
  paths.forEach(async (relativepath, i) => {
    const content = await import_promises3.default.readFile(relativepath, encoding);
    const result = (callback == null ? void 0 : callback(content, i)) || content;
    import_promises3.default.writeFile(relativepath, result).catch((err) => {
      throw err;
    });
  });
}

// src/node/hasPkg.ts
var import_node_path7 = __toESM(require("path"));
function hasPkg(rootPath) {
  const url = import_node_path7.default.resolve(rootPath, "package.json");
  const { result } = jsShell(`test -f "${url}" && echo "0"|| echo "1"`, "pipe");
  return result === "0";
}

// src/node/isInstallPkg.ts
function isInstallPkg(pkg) {
  const { status } = jsShell(`if ! command -v ${pkg} &> /dev/null; then
  exit 1
else
  exit 0
fi`);
  return status === 0;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  fileCopy,
  getExportBundle,
  getPkg,
  getPkgTool,
  hasPkg,
  isInstallPkg,
  jsShell,
  transformArgv,
  useNodeWorker,
  useProcressNodeWorker,
  withTaskName,
  writeFile
});
